local cv_supertimer = CV_RegisterVar({
	name = "supertimer",
	defaultvalue = 50,
	flags = CV_NETVAR,
	PossibleVFalue = CV_Natural
})
local cv_allowsuper = CV_RegisterVar({
    name = "allowsuper",
    defaultvalue = 0,
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff,
})
local cv_supertag = CV_RegisterVar({
	name = "supertag",
	defaultvalue = 0,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff,
})

//Admin tools(by OtherChen) rings command for Supertag.
COM_AddCommand("rings", function(player, amount)
	if not amount then
		CONS_Printf(player, "rings <amount>: give yourself rings")
		return
	end
	
		local N = tonumber(amount)
		if N ~= nil then
			P_GivePlayerRings(player, -9999)
			P_GivePlayerRings(player, N)
		end
end)

COM_AddCommand('togglefly', function(player, arg)
	if arg == nil then
		if fly == 1 then
			fly = 0
		end
		if fly == 0 then
			fly = 1
		end
	end
end)

//literally just Set Emeralds by flarn2006
COM_AddCommand('setemeralds', function(player, arg, arg2)
	if arg == nil or arg2 ~= nil then
		CONS_Printf(player, 'Usage:')
		CONS_Printf(player, 'setemeralds 0    - Remove all emeralds')
		CONS_Printf(player, 'setemeralds all  - Get all emeralds')
		CONS_Printf(player, 'setemeralds 124  - Get emeralds 1, 2, and 4; remove all others')
		CONS_Printf(player, '(Use the same method for any combination of emeralds.)')
	else
		if arg == 'all' then arg = '1234567' end
		local previous = emeralds
		emeralds = 0
		local bit = 1
		for i=1,7 do
			if string.find(arg, tostring(i)) ~= nil then
				emeralds = $ | bit
			end
			bit = $ * 2
		end
		print('Have fun using super forms.')
	end
end, COM_ADMIN)



addHook("MapLoad", do
  if G_TagGametype() then
      if cv_allowsuper.value == 1 then
      COM_BufInsertText(player, "setemeralds all")
	end
	  if cv_supertag.value == 1 then
	  COM_BufInsertText(player, "rings 300")
		if cv_allowsuper.value == 0 then
			COM_BufInsertText(player, "allowsuper 1")
			COM_BufInsertText(player, "supertimer 300")
			COM_BufInsertText(player, "setemeralds all")
		end
	end
  end
end)

COM_AddCommand('taghelp', function(player)
	CONS_Printf(player, 'allowsuper 0/1 - Set forms to be enabled or not.')
	CONS_Printf(player, 'supertimer     - Set time allowed to be super. Default is 50 seconds.')
	CONS_Printf(player, 'supertag   0/1 - Sets rings to 300 at the start of the match.')
end)


//Restrict Super time
//Code borrowed from Zoraxua's Super in Ringslinger
addHook("PlayerThink", function(player)
	if gametype == GT_ZOMBIETAG
	//Local variables to help the game
		if player.iwantemmymusic == nil then player.iwantemmymusic = 0 end
		if player.myemmymusicis == nil then player.myemmymusicis = "_INV" end
	//Poggers

		//Now what's the requirements?
		if player.powers[pw_super] //Don't wanna remove super mid-use
			if player.powers[pw_super] == cv_supertimer.value*TICRATE
				player.powers[pw_super] = 0 //So lose super if you've had it for too long, grr
				player.rings = 0
				//Following ripped from SR lmao
				S_StartSound(nil, sfx_s3k9c) //Trans SFX, global so everyone knows!
				player.mo.color = player.skincolor //Fix supercolor
				player.mo.state = player.mo.state //Go back to normal if you have super sprites
				P_SpawnShieldOrb(player) //Get the sheild back if you had one
				P_RestoreMusic(player) //Fix music if character uses custom for soup
			end
		end
	end
end)

addHook("SpinSpecial",function(player)

	//Custom super activation
	if CanGoSuper(player)
		DoSuperTransform(player,false)
	end
end)